﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using NetShop.models;
using NetShop.libs.encrypt;
using System.Windows.Forms;

namespace NetShop.libs.authentication
{
    class auth
    {
        private string projectDirectory = Directory.GetParent(Environment.CurrentDirectory).Parent.FullName + @"\sessions\";

        private Int32 timeExpired = 28800; // 3600 sec = 1h , 28800 = 8h

        private string sessionDir;

        public auth(string sessionDir)
        {
            this.sessionDir = sessionDir;
        }

        public static auth getInstance(string target)
        {
            return new auth(target + ".sess");
        }

        private aesOperation encryptor = new aesOperation();

        private void saveSession(string username, string password)
        {
            Int32 unixTimestamp = (Int32)(DateTime.UtcNow.Subtract(new DateTime(1970, 1, 1))).TotalSeconds;
            string data = username + "&" + password + "&" + unixTimestamp.ToString();
            File.WriteAllText(projectDirectory + sessionDir, encryptor.EncryptString(data));
        }

        private string[] getDataSession()
        {
            string[] result = new string[] { "" };
            try
            {
                string session = encryptor.DecryptString(File.ReadAllText(projectDirectory + sessionDir));
                result = session.Split('&');
            }
            catch (Exception)
            {
                result[0] = "false";
            }
            return result;
        }

        private bool checkDB(string username, string password)
        {
            bool result = false;
            if (sessionDir == "admin.sess")
            {
                result = admin.instance.checkExist(username, md5.Hash(password));
            }
            if (sessionDir == "user.sess")
            {
                result = user.instance.checkExist(username, md5.Hash(password));
            }
            return result;
        }

        public bool checkLogin()
        {
            if (!File.Exists(projectDirectory + sessionDir))
            {
                return false;
            }
            Int32 unixTimestamp = (Int32)(DateTime.UtcNow.Subtract(new DateTime(1970, 1, 1))).TotalSeconds;
            string[] session = getDataSession();
            if (session[0] == "false" && session.Length == 1)
            {
                return false;
            }
            if (checkDB(session[0], session[1]) && (unixTimestamp - Int32.Parse(session[2]) <= timeExpired))
            {
                return true;
            }
            return false;
        }

        public bool attempt(string username, string password)
        {
            if (checkDB(username, password))
            {
                saveSession(username, password);
                return true;
            }
            return false;
        }

        public void removeSession()
        {
            if (File.Exists(projectDirectory + sessionDir))
            {
                File.Delete(projectDirectory + sessionDir);
            }
        }
    }
}
